/* $Id: user.c 40 2023-04-27 07:29:37Z nishi $ */
#include <swinehub/user.h>

#include <swinehub.h>
#include <swinehub/config.h>
#include <swinehub/repo.h>
#include <swinehub/util.h>
#include <swinehub/language.h>

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>

void swinehub_user(struct swinehub_config* config){
	if(swinehub_check_repo(config) != 1){
		printf("User does not exist.\n");
	}else{
		SW_USER_TITLE;
		printf("<hr>\n");
		int count = 0;
		DIR* dir = opendir(config->path);
		char* result = malloc(1);
		result[0] = 0;
		if(dir != NULL){
			struct dirent* d;
			char* cmp = sstrcat(getenv("PATH_REPLACED") + 2, "-");
			while((d = readdir(dir)) != NULL){
				if(strcmp(d->d_name, ".") == 0 || strcmp(d->d_name, "..") == 0) continue;
				if(strlen(d->d_name) < strlen(cmp)) continue;
				char* tmp = strdup(d->d_name);
				tmp[strlen(cmp)] = 0;
				if(strcmp(tmp, cmp) == 0){
					char* tmpstr = result;
					char* name = sstrcat4("~", getenv("PATH_REPLACED") + 2, "/", d->d_name + strlen(cmp));
					char* link = sstrcat3(getenv("SCRIPT_NAME"), "/", name);
					result = sstrcat6(tmpstr, "<li><a href=\"", link, "\">", name, "</a></li>\n");
					free(link);
					free(name);
					count++;
				}
				free(tmp);
			}
			free(cmp);
			closedir(dir);
		}
		SW_USER_HAS;
		printf("<ul>\n");
		printf("%s\n", result);
		printf("</ul>\n");
		free(result);
	}
}
